<?php
  class dbInterbase extends ADb{
      
           protected $dbType='Interbase';     
      
           public function connect($dbHost,$dbUser,$dbPass,$dbName=false){
                $this->dbhost=$dbHost;
                $this->dbuser=$dbUser;
                $this->dbpass=$dbPass;
                $this->dbname=$dbName; 
                if ($this->check_exists('ibase_connect')) 
                $this->link=@ibase_connect($dbHost,$dbUser,$dbPass);
                if(!$this->link) $this->error('Connection Error : '.$dbHost);
                return $this->link;
           }      
           
           public function  query($sql){
                parent::query($sql);
                $this->lastQuery=@ibase_query($this->link,$this->lastSQL);
                if(!$this->lastQuery) $this->error('Query Error : '.$this->lastSQL); 
           }
           
           public function error($msg){
                echo  parent::error($msg.' ['.$this->ibase_errcode().'] : '.$this->ibase_errmsg());
           }
           
           private function ibase_errcode(){  
               return  @ibase_errcode(); 
           }
            
           private function ibase_errmsg(){
               return @ibase_errmsg();
           }
           
           public function fetch_assoc($query=false){
                    return @ibase_fetch_assoc($query ? $query : $this->lastQuery);
           }
           
           public function fetch_row($query=false){
                   return @ibase_fetch_row($query ? $query:$this->lastQuery);
           }
           
           public function fetch_object($query=false){
                  return @ibase_fetch_object($query?$query:$this->lastQuery);
           }
           
           public function fetch_all($query=false){
               $all=array();
               while ($alls=$this->fetch_assoc()){
                   $all[]=$alls;
               }
               return $all;
           }
           
           public function free($query=false){
               return @ibase_free_query($query?$query:$this->lastQuery);
           }
           
           public function close(){
               return @ibase_close($this->link);
           }
           
           function drop_table($tableName){
              return $this->query('DROP TABLE '.$tableName);
           }
           
           function drop_fields($tableName,$fieldNames){
                 return $this->query('ALTER TABLE '.$tableName.' drop ('.(is_array($fieldNames)?implode(',',$fieldNames) :$fieldNames).')');
           }
                                       
  }    
?>