<?php
  class d3Grid
  {
      # templates
      public $tableStart        = "<table class=\"d3_grid\">\n", 
          $headerCellTemplate   = '<td>{$caption}</td>', 
          $headerTemplate       = "<tr>{\$header}</tr>\n", 
          $cellTemplate         = '<td>{$cellValue}</td>', 
          $rowTemplate          = "<tr>{\$cells}</tr>\n", 
          $tableEnd             = "</table>", 
          $tableTemplate        = '{$tableStart}{$content}{$tableEnd}', 
          $displayError         = true,
          $nullValue            = null;
      # events
      public    $onError, 
                $beforeRowPrint, 
                $beforeCellPrint, 
                $afterRowPrint,
                $captions = array();
      
      private $grid, $name, $array, $cellTempaltes, $rowCount;
      
      /**
       * Constructor
       *
       * @param mixed $array
       * @return d3Grid
       */
      public function d3Grid($array)
      {
          is_array($array) or $this->triggerError('variable you given that is not an array');
          $this->array = $array;
          $this->rowCount = count($array);
      }
      
      /**
      * styled captions
      * etc. 'id'=>'ID Number'
      * @param mixed $array
      */
      public function captions($array){
          $this->captions=$array;
          return $this;
      }
      /**
      * grid rows count
      * @return int
      */
      public function rowCount()
      {
          return $this->rowCount;
      }
      /**
      * build grid return html table string or print
      * @param mixed $return
      */
      public function build($return = false)
      {
          $content = '';
          $header = '';         
          
          $capArray=$this->array[0];  
          foreach($capArray as $keys => $vals)
            $capArray[$keys]=$keys;
          
          foreach ($capArray as $key => $val){
              if (count($this->captions)==0) break;
              foreach ($this->captions as $keyIn => $valIn)
                if ($key==$keyIn)            
                    $capArray[$key]=$valIn;   
          }                              
          $this->captions=$capArray;
          if (count($this->captions) > 0) {
              foreach ($this->captions as $column => $caption) {
                  eval('$header.="' . $this->headerCellTemplate . '";'); 
              }
              eval('$content.="' . addslashes($this->headerTemplate) . '";');  
          }
          
          foreach ($this->array as $rowNum => $cols) {
              $returned = $this->RunEvent($this->beforeRowPrint, array_merge($cols, array('d3Rownum' => $rowNum)));
              if (is_array($returned)){
                  $cols = $returned;
              } elseif ($returned) {
                  $RowTemplate = $returned;
              } else {
                  $RowTemplate = $this->rowTemplate;
              }
              $cells = '';
              foreach ($cols as $colName => $cellValue) {
                  if($cellValue===null)
                  $cellValue=$this->nullValue;
                  $returned = $this->RunEvent($this->beforeCellPrint, array_merge($cols, array('d3SenderColumn' => $colName, 'd3Rownum' => $rowNum)));
                  if (is_array($returned)) {
                      $cols = $returned;
                  } elseif ($returned) {
                      $cellValue = $returned;
                  }
                  extract($cols, EXTR_OVERWRITE);
                  $cellValue = $this->cellTempaltes[$colName] ? $this->cellTempaltes[$colName] : $cellValue;
                  if (!preg_match('/<td/i',$cellValue)) 
                    $cellValue='<td>'.$cellValue.'</td>';
                  eval('$cells.="' . addslashes($cellValue) . '";');
              }
              eval('$content.="' . addslashes($RowTemplate) . '";');
              $content .= $this->RunEvent($this->afterRowPrint, array_merge($cols, array('d3Rownum' => $rowNum)));
          }
          $tableStart = $this->tableStart;
          $tableEnd = $this->tableEnd;
          eval('$this->grid="' . $this->tableTemplate . '";');
          if ($return) {
              return $this->grid;
          } else {
              echo $this->grid;
          }
      }
      
      /**
       * Define Multi template for columns by an array
       *
       * @param mixed $templateArray
       * @param mixed $full
       */
      public function mutliCellTemplate($templateArray, $full = false)
      {
          if ($full) {
              $this->cellTempaltes = $templateArray;
          } else {
              $this->cellTempaltes = array_merge($this->cellTempaltes, $templateArray);
          }
      }
      
      /**
       * Defina a template for a column
       *
       * @param mixed $columnName
       * @param mixed $template
       */
      public function cellTemplate($columnName, $template)
      {
          $this->cellTempaltes[$columnName] = $template;
      }
      /**
       * Error Printing Function.
       * @param mixed $String  Error Message
       */
      private function triggerError($string, $eventArgs = false)
      {
          if ($this->OnError) {
              $this->RunEvent($this->OnError, $eventArgs ? $eventArgs : (object)$this->getByIndex(debug_backtrace(), 1));
          } else {
              
              if ($this->displayError) {
                  die('<div><b>Error :</b>' . $string . "<br><pre>" . print_r($eventArgs ? $eventArgs : $this->getByIndex(debug_backtrace(), 1), true) . "</div>\n");
              }
          }
      }
      
      /**
       * Return element from an array by index
       *
       * @param mixed $array
       * @param mixed $index
       * @return mixed
       */
      private function getByIndex($array, $index)
      {
          return $array[$index];
      }
      
      /**
       * Event Runner
       * @param mixed $EventName Func Name
       * @param mixed $Param  Func Param(s)
       * @return mixed Func Result which called
       */
      private function RunEvent($eventName, $Param = false)
      {
          if (function_exists($eventName)) {
              if ($Param) {
                  return call_user_func($eventName, $Param);
              } else {
                  return call_user_func($eventName);
              }
          }
      }
  }
?>